"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NestjsMicroservicesCqrsModule = void 0;
const common_1 = require("@nestjs/common");
const cqrs_1 = require("@nestjs/cqrs");
const explorer_service_1 = require("@nestjs/cqrs/dist/services/explorer.service");
const services_1 = require("./services");
const event_bus_1 = require("./event-bus");
let NestjsMicroservicesCqrsModule = class NestjsMicroservicesCqrsModule {
    constructor(explorerService, eventsBus, commandsBus, queryBus) {
        this.explorerService = explorerService;
        this.eventsBus = eventsBus;
        this.commandsBus = commandsBus;
        this.queryBus = queryBus;
    }
    onApplicationBootstrap() {
        const { events, queries, sagas, commands } = this.explorerService.explore();
        this.eventsBus.register(events);
        this.commandsBus.register(commands);
        this.queryBus.register(queries);
        this.eventsBus.registerSagas(sagas);
    }
};
NestjsMicroservicesCqrsModule = __decorate([
    common_1.Module({
        providers: [cqrs_1.CommandBus, cqrs_1.QueryBus, event_bus_1.EventBus, cqrs_1.EventPublisher, explorer_service_1.ExplorerService, services_1.NestjsMicroservicesCqrs],
        exports: [cqrs_1.CommandBus, cqrs_1.QueryBus, event_bus_1.EventBus, cqrs_1.EventPublisher],
    }),
    __metadata("design:paramtypes", [explorer_service_1.ExplorerService,
        event_bus_1.EventBus,
        cqrs_1.CommandBus,
        cqrs_1.QueryBus])
], NestjsMicroservicesCqrsModule);
exports.NestjsMicroservicesCqrsModule = NestjsMicroservicesCqrsModule;
