import { EventBus as BaseEventBus, IEventBus, EventHandlerType, IEventHandler } from "@nestjs/cqrs";
import { OnModuleDestroy } from "@nestjs/common";
import { ModuleRef } from '@nestjs/core';
import { CommandBus } from '@nestjs/cqrs/dist/command-bus';
import { NestjsMicroservicesCqrs } from './services';
import { ISerializableEvent } from "./serializable";
export declare class EventBus<EventBase extends ISerializableEvent = ISerializableEvent> extends BaseEventBus<EventBase> implements IEventBus<EventBase>, OnModuleDestroy {
    private readonly _commandBus;
    private readonly _moduleRef;
    private readonly _nmc;
    constructor(_commandBus: CommandBus, _moduleRef: ModuleRef, _nmc: NestjsMicroservicesCqrs);
    private isLocal;
    private splitEventsListLocalGlobal;
    publish<T extends EventBase>(event: T): any;
    publishLocally<T extends EventBase>(event: T): any;
    publishAll<T extends EventBase>(events: T[]): any;
    publishAllLocally<T extends EventBase>(events: T[]): any;
    private emit;
    bind(handler: IEventHandler<EventBase>, name: string): void;
    protected registerHandler(handler: EventHandlerType<EventBase>): void;
    private subscribeGlobally;
    private _reflectGlobalEvent;
    private _reflectEventsNames;
}
